<xsl:template name="max-depth">
  <xsl:variable name="all" select=".//*[not(*)]"/>
  <xsl:variable name="initial-depth" select="count(ancestor::node())"/>
  <xsl:for-each select="$all">
    <xsl:variable name="depth" select="count(ancestor::node())"/>
    <xsl:variable name="first-node"
                  select="$all[count(ancestor::node()) = $depth][1]"/>
    <xsl:variable name="is-deepest"
                  select="not($all[count(ancestor::node()) > $depth)"/>
    <xsl:if test="$is-deepest and
               generate-id(current()) = generate-id($first-node))">
      <!-- Print the value only once by stopping at the first node
           that is the deepest (in case of ties) -->
      <xsl:value-of select="$depth - $initial-depth"/>
    </xsl:if>
  </xsl:for-each>
</xsl:template>