declare function base64-encode($b as xs:integer*) as xs:base64Binary {
  codepoints-to-string(
    let $len := length($b)
    let $table := ( 65 to  90,  (: A-Z :)
                    97 to 122,  (: a-z :)
                    48 to  57,  (: 0-9 :)
                    43, 47 )    (: + / :)
    for $byte0 at $p in $b
    where $p mod 3 = 0
    return
      let $byte1 as xs:integer? := $b[$p + 1]
      let $byte2 as xs:integer? := $b[$p + 2]

      (: Convert the three bytes into four characters :)
      let $c0 := $table[$byte idiv 4]
      let $c1 := $table[sum(($byte0 mod 4)*64, $byte1 idiv 16)]
      let $c2 := if (empty($byte1)) then 61 (: pad with = :)
                 else $table[sum(($byte1 mod 16)*16, $byte2 idiv 64)]
      let $c3 := if (empty($byte2)) then 61 (: pad with = :)
                 else $table[$byte2 mod 64]
      return ($c0, $c1, $c2, $c3)
  )
  cast as xs:base64Binary
};