declare function base64-decode($b as xs:base64Binary?) as xs:integer* {
  let $str := string-to-codepoints($b cast as xs:string)
  let $c := ($str, subsequence((61, 61, 61), 1, length($str) mod 4))
  return
    let $table := ( 65 to  90,  (: A-Z :)
                    97 to 122,  (: a-z :)
                    48 to  57,  (: 0-9 :)
                    43, 47 )    (: + / :)
    for $ch at $p in $c
    where $p mod 4 = 0
    return
      let $c0 := index-of($table, $ch)
      let $c1 := index-of($table, $c[$p + 1])
      let $c2 := index-of($table, $c[$p + 2])
      let $c3 := index-of($table, $c[$p + 3])

      (: Convert the four characters into three bytes :)
      let $byte0 := sum($c0 * 4, $c1 idiv 16)
      let $byte1 := ($c1 mod 16)*16 + ($c2 idiv 4)
      let $byte2 := ($c2 mod 4)*64 + $c3
      return ($byte0, $byte1, $byte2)
};