declare function hex-encode($seq as xs:integer*) as xs:hexBinary {
  codepoints-to-string(
    let $table := (48 to 57, 65 to 70)  (: 0-9, A-F :)
    for $b in $seq
    return ($table[$b idiv 16], $table[$b mod 16])
  )
  cast as xs:hexBinary
};

declare function hex-decode($bin as xs:hexBinary) as xs:integer* {
  let $chars := string-to-codepoints($bin cast as xs:string)
  for $c0 at $p in $chars
  where $p mod 2 = 0
  return
    let $c1 := $chars[$p + 1]
    let $byte0 := if ($c0 < 65) then ($c0 - 48) else ($c0 - 55)
    let $byte1 := if ($c1 < 65) then ($c1 - 48) else ($c1 - 55)
    return $byte0 * 16 + $byte1
};