declare function complex-to-string($complex as xs:double*) {
  if (count($complex) != 2) then error("Invalid complex number")
  else concat(string($complex[1]), " + ", string($complex[2]), "i")
};

declare function real($complex as xs:double*) as xs:double {
  if (count($complex) != 2) then error("Invalid complex number")
  else $complex[1] treat as xs:double
};

declare function imag($complex as xs:double*) as xs:double {
  if (count($complex) != 2) then error("Invalid complex number")
  else $complex[2] treat as xs:double
};

(: depends on sqrt() example in Listing 10.52)
declare function magnitude($complex as xs:double*) as xs:double {
  if (count($complex) != 2) then error("Invalid complex number")
  else sqrt($complex[1]*$complex[1] + $complex[2]*$complex[2])
};

declare function add-complex($lhs as xs:double*,
                            $rhs as xs:double*) as xs:double* {
  if (count($lhs) != 2 or count($rhs) != 2) then error("Invalid")
  else ($lhs[1] + $rhs[1], $lhs[2] + $rhs[2])
};

declare function multiply-complex($lhs as xs:double*,
                                 $rhs as xs:double*) as xs:double* {
  if (count($lhs) != 2 or count($rhs) != 2) then error("Invalid")
  else ($lhs[1] * $rhs[1] - $lhs[2] * $rhs[2],
        $lhs[1] * $rhs[2] + $lhs[2] * $rhs[1])
};

 (: etc. :)
