declare function vector-add($lhs, $rhs) {
  if (count($lhs) != count($rhs)) then error("Vector length mismatch")
  else
    for $i at $p in $lhs
    return $i + $rhs[$p]
};

declare function vector-subtract($lhs, $rhs) {
  if (count($lhs) != count($rhs)) then error("Vector length mismatch")
  else
    for $i at $p in $lhs
    return $i - $rhs[$p]
};

declare function vector-negate($arg) {
  for $i in $lhs
  return -$i
};

declare function original($len as xs:integer) {
  for $i in (1 to $len)
  return 0
};

declare function vector-dot($lhs, $rhs) {
  if (count($lhs) != count($rhs)) then error("Vector length mismatch")
  else
    sum(
      for $i at $p in $lhs
      return $i * $rhs[$p]
    )
};

(: requires the sqrt() function from Listing 10.52 :)
declare function vector-length($arg) {
  sqrt(vector-dot($arg, $arg))
};

declare function vector-distance($lhs, $rhs) {
  vector-length(vector-subtract($lhs, $rhs))
};
